IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CFOP_ITEM' AND
	        TYPE = 'FN' 		     AND
	        U.UID = O.UID        AND
	        U.NAME = USER)
DROP FUNCTION CFOP_ITEM
GO
CREATE FUNCTION CFOP_ITEM
   (@P_CDEMPRESA   VARCHAR(02),
    @P_CDINSCESTA  VARCHAR(16),
    @P_CDFILIAL    VARCHAR(04),
    @P_CDCLIENTE   VARCHAR(21),
    @P_CDOPERACAO  VARCHAR(02),
    @P_DTVALIDCFOP DATETIME,
    @P_CDARVPROD   VARCHAR(20),
    @P_PAISORIG    VARCHAR(04),
    @P_ESTAORIG    VARCHAR(02),
    @P_PAISDEST    VARCHAR(04),
    @P_ESTADEST    VARCHAR(02)) RETURNS VARCHAR
AS
BEGIN
   DECLARE @V_CFOPITEM     VARCHAR(14);
   DECLARE @V_CFOP1DIGT    VARCHAR(1);
   DECLARE @V_CDARVPROD    VARCHAR(20);
   DECLARE @V_CONTADOR     INT;
   DECLARE @V_CDGRUPOFISC  VARCHAR(02);

   EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE, @P_CDFILIAL, 'S', @P_CDOPERACAO, @V_CDGRUPOFISC;

   IF @P_PAISORIG = @P_PAISDEST BEGIN
      IF @P_ESTAORIG = @P_ESTADEST BEGIN
         SET @V_CFOP1DIGT = '5';
      END
      ELSE BEGIN
         SET @V_CFOP1DIGT = '6';
      END;
   END
   ELSE BEGIN
      SET @V_CFOP1DIGT = '7';
   END;

/* Retorna o grupo fiscal para as operaes interestaduais */
   IF @V_CFOP1DIGT = '6' BEGIN
      SELECT @V_CDGRUPOFISC = SUBSTRING(DSPARGERFIS,3,3)
      FROM PARAMGERAL;
   END;

   IF @V_CDGRUPOFISC IS NULL BEGIN
      SET @V_CDGRUPOFISC = @V_CDGRUPOFISC;
   END;

   IF @V_CDGRUPOFISC IS NOT NULL BEGIN
      SELECT @V_CDARVPROD = MAX(P.CDARVPROD),
             @V_CONTADOR = COUNT(*)
      FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO  = P.CDPRODUTO)
      WHERE (IDENTSAICFOP = 'S')              AND
            (CDEMPRESA    = @P_CDEMPRESA)     AND
            (CDTIPOOPER   = @P_CDOPERACAO)    AND
            (CDINSCESTA   = @P_CDINSCESTA)    AND
            (CDGRUPOFISC  = @V_CDGRUPOFISC)   AND
            (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD),@P_CDARVPROD) = 1);
   END;

   IF @V_CONTADOR > 0 BEGIN
      IF NOT (@V_CDARVPROD IS NULL) BEGIN
         SELECT @V_CFOPITEM = MAX(CDFISCOPER)
         FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO    = P.CDPRODUTO)
         WHERE (C.IDENTSAICFOP = 'S')               AND
               (C.CDEMPRESA    = @P_CDEMPRESA)      AND
               (C.CDTIPOOPER   = @P_CDOPERACAO)     AND
               (C.CDINSCESTA   = @P_CDINSCESTA)     AND
               (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
               (P.CDARVPROD    = @V_CDARVPROD)      AND
               (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                  FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO = P.CDPRODUTO)
                                  WHERE (C.IDENTSAICFOP = 'S')               AND
                                        (C.CDEMPRESA    = @P_CDEMPRESA)      AND
                                        (C.CDTIPOOPER   = @P_CDOPERACAO)     AND
                                        (C.CDINSCESTA   = @P_CDINSCESTA)     AND
                                        (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                                        (P.CDARVPROD    = @V_CDARVPROD)      AND
                                        (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
      END
      ELSE BEGIN
         IF (@V_CDARVPROD IS NULL) BEGIN
            SELECT @V_CFOPITEM = MAX(CDFISCOPER)
            FROM CODFISCOPER C
            WHERE (C.IDENTSAICFOP = 'S')              AND
                  (C.CDEMPRESA    = @P_CDEMPRESA)      AND
                  (C.CDTIPOOPER   = @P_CDOPERACAO)     AND
                  (C.CDINSCESTA   = @P_CDINSCESTA)     AND
                  (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                  (C.CDPRODUTO IS NULL)               AND
                  (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                     FROM CODFISCOPER C
                                     WHERE (C.IDENTSAICFOP = 'S')              AND
                                           (C.CDEMPRESA    = @P_CDEMPRESA)     AND
                                           (C.CDTIPOOPER   = @P_CDOPERACAO)    AND
                                           (C.CDINSCESTA   = @P_CDINSCESTA)    AND
                                           (C.CDGRUPOFISC  = @V_CDGRUPOFISC)   AND
                                           (C.CDPRODUTO   IS NULL)             AND
                                           (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
         END;
      END;
   END
   ELSE BEGIN
      SELECT @V_CDARVPROD = MAX(P.CDARVPROD)
      FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO = P.CDPRODUTO)
      WHERE (IDENTSAICFOP = 'S')             AND
            (CDEMPRESA    = @P_CDEMPRESA)    AND
            (CDTIPOOPER   = @P_CDOPERACAO)   AND
            (CDINSCESTA   = @P_CDINSCESTA)   AND
            (CDGRUPOFISC IS NULL)            AND
            (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD), @P_CDARVPROD) = 1);

      IF NOT (@V_CDARVPROD IS NULL) BEGIN
         SELECT @V_CFOPITEM = MAX(CDFISCOPER)
         FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO = P.CDPRODUTO)
         WHERE (C.IDENTSAICFOP = 'S')              AND
               (C.CDEMPRESA    = @P_CDEMPRESA)     AND
               (C.CDTIPOOPER   = @P_CDOPERACAO)    AND
               (C.CDINSCESTA   = @P_CDINSCESTA)    AND
               (C.CDGRUPOFISC IS NULL)             AND
               (P.CDARVPROD    = @V_CDARVPROD)     AND
               (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                  FROM CODFISCOPER C LEFT JOIN PRODUTO P ON (C.CDPRODUTO = P.CDPRODUTO)
                                  WHERE (C.IDENTSAICFOP = 'S')              AND
                                        (C.CDEMPRESA    = @P_CDEMPRESA)     AND
                                        (C.CDTIPOOPER   = @P_CDOPERACAO)    AND
                                        (C.CDINSCESTA   = @P_CDINSCESTA)    AND
                                        (C.CDGRUPOFISC  IS NULL)            AND
                                        (P.CDARVPROD    = @V_CDARVPROD)     AND
                                        (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
      END
      ELSE BEGIN
         IF (@V_CDARVPROD IS NULL) BEGIN
            SELECT @V_CFOPITEM = MAX(CDFISCOPER)
            FROM CODFISCOPER C
            WHERE (C.IDENTSAICFOP = 'S')              AND
                  (C.CDEMPRESA    = @P_CDEMPRESA)      AND
                  (C.CDTIPOOPER   = @P_CDOPERACAO)     AND
                  (C.CDINSCESTA   = @P_CDINSCESTA)     AND
                  (C.CDGRUPOFISC IS NULL)             AND
                  (C.CDPRODUTO IS NULL)               AND
                  (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                     FROM CODFISCOPER C
                                     WHERE (C.IDENTSAICFOP = 'S')              AND
                                           (C.CDEMPRESA    = @P_CDEMPRESA)      AND
                                           (C.CDTIPOOPER   = @P_CDOPERACAO)     AND
                                           (C.CDINSCESTA   = @P_CDINSCESTA)     AND
                                           (C.CDGRUPOFISC  IS NULL)            AND
                                           (C.CDPRODUTO    IS NULL)            AND
                                           (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
         END;
      END;
   END;

   IF (@V_CFOPITEM IS NOT NULL) BEGIN
      SET @V_CFOPITEM = '  '+@V_CFOP1DIGT+@V_CFOPITEM;
   END;

   RETURN (@V_CFOPITEM);
END
GO
