<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class VabBeneficiom extends \Doctrine\ORM\EntityRepository {
    
    public function retornaBeneficio($nrorg, $dtmescompetenc, $nrbeneficiom){
        
        $beneficiom = Repositories::VAB_BENEFICIOM;
        $beneficioh = Repositories::VAB_BENEFICIOH;
        
$sql = <<<SQL
SELECT beneficiom, beneficioh
  FROM $beneficiom beneficiom
  JOIN $beneficioh beneficioh WITH beneficioh.nrorg = beneficiom.nrorg
                               AND beneficioh.nrbeneficiom = beneficiom.nrbeneficiom
                               AND beneficioh.dtmescompetenc = (SELECT MAX(eh.dtmescompetenc)
                                                                  FROM $beneficioh eh
                                                                 WHERE eh.nrorg = beneficioh.nrorg
                                                                   AND eh.nrbeneficiom = beneficioh.nrbeneficiom
                                                                   AND eh.dtmescompetenc <= :p_dtmescompetenc)
 WHERE beneficiom.nrorg = :p_nrorg
   AND beneficioh.nrbeneficiom = :p_nrbeneficiom
SQL;
        $params = array(
            'p_nrorg'          => $nrorg,
            'p_dtmescompetenc' => $dtmescompetenc,
            'p_nrbeneficiom'   => $nrbeneficiom,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $resultado = array();
        foreach ($result as $key => $param) {
            if($param instanceof $beneficiom){
                $param->historico = $result[$key+1];
                $resultado[] = $param;
            }    
        }
        return $resultado;
    }
    
    public function retornaBeneficiosSindicato($nrorg, $dtmescompetenc, $nrestrutsind){
        
        $beneficiom = Repositories::VAB_BENEFICIOM;
        $beneficioh = Repositories::VAB_BENEFICIOH;
        
$sql = <<<SQL
SELECT beneficiom, beneficioh
  FROM $beneficiom beneficiom
  JOIN $beneficioh beneficioh WITH beneficioh.nrorg = beneficiom.nrorg
                               AND beneficioh.nrbeneficiom = beneficiom.nrbeneficiom
                               AND beneficioh.dtmescompetenc = (SELECT MAX(eh.dtmescompetenc)
                                                                  FROM $beneficioh eh
                                                                 WHERE eh.nrorg = beneficioh.nrorg
                                                                   AND eh.nrbeneficiom = beneficioh.nrbeneficiom
                                                                   AND eh.dtmescompetenc <= :p_dtmescompetenc)
 WHERE beneficiom.nrorg = :p_nrorg
   AND beneficioh.nrestrutsind = :p_nrestrutsind
SQL;
        $params = array(
            'p_nrorg'          => $nrorg,
            'p_dtmescompetenc' => $dtmescompetenc,
            'p_nrestrutsind'   => $nrestrutsind,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $resultado = array();
        foreach ($result as $key => $param) {
            if($param instanceof $beneficiom){
                $param->historico = $result[$key+1];
                $resultado[] = $param;
            }    
        }
        return $resultado;
    }
    
    public function retornaBeneficioPorPropriedades($nrorg, $dtmescompetenc, $dsbeneficio=null){
        
        $beneficiom = Repositories::VAB_BENEFICIOM;
        $beneficioh = Repositories::VAB_BENEFICIOH;
        
$sql = <<<SQL
SELECT beneficiom, beneficioh
  FROM $beneficiom beneficiom
  JOIN $beneficioh beneficioh WITH beneficioh.nrorg = beneficiom.nrorg
                               AND beneficioh.nrbeneficiom = beneficiom.nrbeneficiom
                               AND beneficioh.dtmescompetenc = (SELECT MAX(eh.dtmescompetenc)
                                                                  FROM $beneficioh eh
                                                                 WHERE eh.nrorg = beneficioh.nrorg
                                                                   AND eh.nrbeneficiom = beneficioh.nrbeneficiom
                                                                   AND eh.dtmescompetenc <= :p_dtmescompetenc)
 WHERE beneficiom.nrorg = :p_nrorg
   AND (beneficioh.dsbeneficio = :p_dsbeneficio OR :p_dsbeneficio IS NULL)
SQL;
        $params = array(
            'p_nrorg'          => $nrorg,
            'p_dtmescompetenc' => $dtmescompetenc,
            'p_dsbeneficio'    => $dsbeneficio,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $resultado = array();
        foreach ($result as $key => $param) {
            if($param instanceof $beneficiom){
                $param->historico = $result[$key+1];
                $resultado[] = $param;
            }    
        }
        return $resultado;
    }
    
}